## mujs 1.1.0

=== Makefile ===
# Build type and install directories:

build ?= release

prefix ?= /usr/local
bindir ?= $(prefix)/bin
incdir ?= $(prefix)/include
libdir ?= $(prefix)/lib

ifeq "$(wildcard .git)" ".git"
  VERSION := $(shell git describe --tags --always)
else
  VERSION := $(shell basename $$PWD | sed -e s,^mujs-,,)
endif

# Compiler flags for various configurations:

CFLAGS += -std=c99 -pedantic -Wall -Wextra -Wno-unused-parameter

ifeq "$(CC)" "clang"
  CFLAGS += -Wunreachable-code
endif

ifeq "$(shell uname)" "Linux"
  HAVE_READLINE := yes
endif

ifeq "$(build)" "debug"
  CFLAGS += -g
else ifeq "$(build)" "sanitize"
  CFLAGS += -pipe -g -fsanitize=address -fno-omit-frame-pointer
  LDFLAGS += -fsanitize=address
else ifeq "$(build)" "release"
  CFLAGS += -Os
  LDFLAGS += -Wl,-s
endif

ifeq "$(HAVE_READLINE)" "yes"
  CFLAGS += -DHAVE_READLINE
  LIBREADLINE += -lreadline
endif

CFLAGS += $(XCFLAGS)

# You shouldn't need to edit anything below here.

OUT := build/$(build)

SRCS := $(wildcard js*.c utf*.c regexp.c)
HDRS := $(wildcard js*.h mujs.h utf.h regexp.h)

default: shell
shell: $(OUT)/mujs $(OUT)/mujs-pp
static: $(OUT)/libmujs.a
shared: $(OUT)/libmujs.so

astnames.h: jsparse.h
	grep -E '(AST|EXP|STM)_' jsparse.h | sed 's/^[^A-Z]*\(AST_\)*/"/;s/,.*/",/' | tr A-Z a-z > $@

opnames.h: jscompile.h
	grep -E 'OP_' jscompile.h | sed 's/^[^A-Z]*OP_/"/;s/,.*/",/' | tr A-Z a-z > $@

one.c: $(SRCS)
	ls $(SRCS) | awk '{print "#include \""$$1"\""}' > $@

jsdump.c: astnames.h opnames.h

$(OUT)/%.o: %.c $(HDRS)
	@ mkdir -p $(dir $@)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ -c $<

$(OUT)/libmujs.o: one.c $(HDRS)
	@ mkdir -p $(dir $@)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ -c $<

$(OUT)/libmujs.a: $(OUT)/libmujs.o
	@ mkdir -p $(dir $@)
	$(AR) cr $@ $^

$(OUT)/libmujs.so: one.c $(HDRS)
	@ mkdir -p $(dir $@)
	$(CC) $(CFLAGS) $(CPPFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $< -lm

$(OUT)/mujs: $(OUT)/libmujs.o $(OUT)/main.o
	@ mkdir -p $(dir $@)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBREADLINE) -lm

$(OUT)/mujs-pp: $(OUT)/libmujs.o $(OUT)/pp.o
	@ mkdir -p $(dir $@)
	$(CC) $(LDFLAGS) -o $@ $^ -lm

.PHONY: $(OUT)/mujs.pc
$(OUT)/mujs.pc:
	@ echo Creating $@
	@ echo > $@ Name: mujs
	@ echo >> $@ Description: MuJS embeddable Javascript interpreter
	@ echo >> $@ Version: $(VERSION)
	@ echo >> $@ Cflags: -I$(incdir)
	@ echo >> $@ Libs: -L$(libdir) -lmujs
	@ echo >> $@ Libs.private: -lm

watch:
	@ while ! inotifywait -q -e modify $(SRCS) $(HDRS) ; do time -p $(MAKE) ; done

install-common: $(OUT)/mujs $(OUT)/mujs.pc
	install -d $(DESTDIR)$(incdir)
	install -d $(DESTDIR)$(libdir)
	install -d $(DESTDIR)$(libdir)/pkgconfig
	install -d $(DESTDIR)$(bindir)
	install -m 644 mujs.h $(DESTDIR)$(incdir)
	install -m 644 $(OUT)/mujs.pc $(DESTDIR)$(libdir)/pkgconfig
	install -m 755 $(OUT)/mujs $(DESTDIR)$(bindir)

install-static: install-common $(OUT)/libmujs.a
	install -m 644 $(OUT)/libmujs.a $(DESTDIR)$(libdir)

install-shared: install-common $(OUT)/libmujs.so
	install -m 755 $(OUT)/libmujs.so $(DESTDIR)$(libdir)

install: install-static

uninstall:
	rm -f $(DESTDIR)$(bindir)/mujs
	rm -f $(DESTDIR)$(incdir)/mujs.h
	rm -f $(DESTDIR)$(libdir)/pkgconfig/mujs.pc
	rm -f $(DESTDIR)$(libdir)/libmujs.a
	rm -f $(DESTDIR)$(libdir)/libmujs.so

tarball:
	git archive --format=zip --prefix=mujs-$(VERSION)/ HEAD > mujs-$(VERSION).zip
	git archive --format=tar --prefix=mujs-$(VERSION)/ HEAD | gzip > mujs-$(VERSION).tar.gz
	git archive --format=tar --prefix=mujs-$(VERSION)/ HEAD | xz > mujs-$(VERSION).tar.xz

tags: $(SRCS) main.c $(HDRS)
	ctags $^

clean:
	rm -rf build

nuke: clean
	rm -f astnames.h opnames.h one.c

debug:
	$(MAKE) build=debug

sanitize:
	$(MAKE) build=sanitize

release:
	$(MAKE) build=release

.PHONY: default static shared shell clean nuke
.PHONY: install install-common install-shared install-static
.PHONY: debug sanitize release

## mujs 1.0.7

=== debian/changelog ===
mujs (1.0.7-2) unstable; urgency=medium

  * Update debhelper version
  * Add CI
  * Add CFLAGS and CPPFLAGS
  * Patch: Set LDFLAGS for shared lib
  * Patch: Set the right .pc version

 -- Bastian Germann <bastiangermann@fishpost.de>  Wed, 17 Jun 2020 01:50:25 +0200

mujs (1.0.7-1) unstable; urgency=medium

  * New upstream version 1.0.7

 -- Bastian Germann <bastiangermann@fishpost.de>  Thu, 23 Apr 2020 17:08:55 +0200

mujs (1.0.6-3) unstable; urgency=medium

  [ Bastian Germann ]
  * Update Vcs fields because user changed

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_build pass cross tools to make. (Closes: #958281)

 -- Bastian Germann <bastiangermann@fishpost.de>  Mon, 20 Apr 2020 17:24:29 +0200

mujs (1.0.6-2) unstable; urgency=medium

  * Set Vcs fields

 -- Bastian Germann <bastiangermann@fishpost.de>  Sat, 11 Apr 2020 15:33:46 +0200

mujs (1.0.6-1) unstable; urgency=medium

  * Initial release (Closes: #950187)

 -- Bastian Germann <bastiangermann@fishpost.de>  Wed, 29 Jan 2020 20:28:50 +0100

=== debian/control ===
Source: mujs
Priority: optional
Maintainer: Bastian Germann <bastiangermann@fishpost.de>
Build-Depends: debhelper-compat (= 13), dh-exec, libreadline-dev
Standards-Version: 4.5.0
Section: javascript
Rules-Requires-Root: no
Homepage: https://mujs.com/
Vcs-Browser: https://salsa.debian.org/bage/mujs
Vcs-Git: https://salsa.debian.org/bage/mujs.git

Package: libmujs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmujs1 (= ${binary:Version}), ${misc:Depends}
Description: Lightweight JavaScript interpreter (development package)
 MuJS is a lightweight JavaScript interpreter designed for embedding in other
 software to extend them with scripting capabilities.
 .
 MuJS was designed with a focus on small size, correctness, and simplicity.
 It is written in portable C and implements ECMAScript as specified by ECMA-262.
 The interface for binding with native code is designed to be as simple as
 possible to use, and is very similar to Lua. There is no need to interact with
 byzantine C++ template mechanisms, or worry about marking and unmarking garbage
 collection roots, or wrestle with obscure build systems.

Package: libmujs1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight JavaScript interpreter library
 MuJS is a lightweight JavaScript interpreter designed for embedding in other
 software to extend them with scripting capabilities.
 .
 MuJS was designed with a focus on small size, correctness, and simplicity.
 This package contains the shared runtime library.

Package: mujs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight JavaScript interpreter
 MuJS is a lightweight JavaScript interpreter designed for embedding in other
 software to extend them with scripting capabilities.
 .
 MuJS was designed with a focus on small size, correctness, and simplicity.
 This package contains the command line interpreter.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DESTDIR = debian/tmp
export build = debug
export prefix = /usr
export libdir = $(prefix)/lib/${DEB_HOST_MULTIARCH}
export CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- XCFLAGS="$(CFLAGS) -Wl,-soname,libmujs.so.1" shared
	dh_auto_build -- XCFLAGS="$(CFLAGS)"

override_dh_auto_install:
	$(MAKE) install-shared
	dh_auto_install --destdir=$(DESTDIR)

## mujs 1.0.9

=== debian/changelog ===
mujs (1.0.9-1) unstable; urgency=medium

  * Unify patch format
  * Remove one dh-exec use
  * Remove orphaned dh-exec
  * Add patch: Install versioned shared library
  * Add Forwarded tag to patch
  * Add symbols file
  * d/watch: Change to git because of lacking releases
  * New upstream version 1.0.9

 -- Bastian Germann <bastiangermann@fishpost.de>  Wed, 07 Oct 2020 21:56:47 +0200

## mujs 1.1.0

=== debian/changelog ===
mujs (1.1.0-1+deb11u3) bullseye; urgency=medium

  * Fix CVE-2021-33797 via upstream patch

 -- Bastian Germann <bage@debian.org>  Fri, 19 May 2023 10:44:27 +0200

mujs (1.1.0-1+deb11u2) bullseye-security; urgency=medium

  * Fix CVE-2022-44789, CVE-2022-30974, and CVE-2022-30975 via upstream patches

 -- Bastian Germann <bage@debian.org>  Mon, 21 Nov 2022 13:10:02 +0100

mujs (1.1.0-1+deb11u1) bullseye; urgency=high

  * Clear jump list after patching jump addresses (CVE-2021-45005)

 -- Bastian Germann <bage@debian.org>  Fri, 25 Feb 2022 21:18:16 +0100

mujs (1.1.0-1) unstable; urgency=medium

  * Import new upstream version
  * Refresh patches
  * Remove now unnecessary flag combination

 -- Bastian Germann <bastiangermann@fishpost.de>  Thu, 18 Feb 2021 19:47:17 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: mujs
 Priority: optional
 Maintainer: Bastian Germann <bastiangermann@fishpost.de>
-Build-Depends: debhelper-compat (= 13), dh-exec, libreadline-dev
+Build-Depends: debhelper-compat (= 13), libreadline-dev
 Standards-Version: 4.5.0
 Section: javascript
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DESTDIR = debian/tmp
export build = debug
export prefix = /usr
export libdir = $(prefix)/lib/${DEB_HOST_MULTIARCH}

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- XCFLAGS="-Wl,-soname,libmujs.so.1" shared
	dh_auto_build

override_dh_auto_install:
	$(MAKE) install-shared
	dh_auto_install --destdir=$(DESTDIR)

## mujs 1.1.3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,6 @@
 # Build type and install directories:
+
+-include user.make
 
 build ?= release
 
@@ -15,7 +17,7 @@
 
 # Compiler flags for various configurations:
 
-CFLAGS += -std=c99 -pedantic -Wall -Wextra -Wno-unused-parameter
+CFLAGS := -std=c99 -pedantic -Wall -Wextra -Wno-unused-parameter
 
 ifeq "$(CC)" "clang"
   CFLAGS += -Wunreachable-code
@@ -31,7 +33,7 @@
   CFLAGS += -pipe -g -fsanitize=address -fno-omit-frame-pointer
   LDFLAGS += -fsanitize=address
 else ifeq "$(build)" "release"
-  CFLAGS += -Os
+  CFLAGS += -O2
   LDFLAGS += -Wl,-s
 endif
 
@@ -41,6 +43,7 @@
 endif
 
 CFLAGS += $(XCFLAGS)
+CPPFLAGS += $(XCPPFLAGS)
 
 # You shouldn't need to edit anything below here.

=== debian/changelog ===
mujs (1.1.3-3) unstable; urgency=medium

  * Move git to debian namespace
  * Set bage's debian.org email
  * d/copyright: utftype.c is also (c) by Lucent

 -- Bastian Germann <bage@debian.org>  Sat, 04 Dec 2021 10:54:09 +0100

mujs (1.1.3-2) unstable; urgency=medium

  * Move experimental to unstable

 -- Bastian Germann <bastiangermann@fishpost.de>  Mon, 23 Aug 2021 12:34:25 +0200

mujs (1.1.3-1) experimental; urgency=medium

  * Import new upstream version
  * Revert "d/watch: Change to git because of lacking releases"
  * Upstream forwards the download page

 -- Bastian Germann <bastiangermann@fishpost.de>  Fri, 18 Jun 2021 18:41:18 +0200

mujs (1.1.2-1) experimental; urgency=medium

  * Import new upstream version
  * Add new symbols
  * Rework compiler flags once again

 -- Bastian Germann <bastiangermann@fishpost.de>  Wed, 28 Apr 2021 23:47:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: mujs
 Priority: optional
-Maintainer: Bastian Germann <bastiangermann@fishpost.de>
+Maintainer: Bastian Germann <bage@debian.org>
 Build-Depends: debhelper-compat (= 13), libreadline-dev
 Standards-Version: 4.5.0
 Section: javascript
 Rules-Requires-Root: no
 Homepage: https://mujs.com/
-Vcs-Browser: https://salsa.debian.org/bage/mujs
-Vcs-Git: https://salsa.debian.org/bage/mujs.git
+Vcs-Browser: https://salsa.debian.org/debian/mujs
+Vcs-Git: https://salsa.debian.org/debian/mujs.git
 
 Package: libmujs-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -8,13 +8,14 @@
 export build = debug
 export prefix = /usr
 export libdir = $(prefix)/lib/${DEB_HOST_MULTIARCH}
+CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 
 %:
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- XCFLAGS="-Wl,-soname,libmujs.so.1" shared
-	dh_auto_build
+	dh_auto_build -- CFLAGS="$(CFLAGS) -Wl,-soname,libmujs.so.1" shared
+	dh_auto_build -- CFLAGS="$(CFLAGS)"
 
 override_dh_auto_install:
 	$(MAKE) install-shared

=== debian/watch ===
version=4
https://mujs.com/downloads/mujs-(\d\S+).tar.xz

## mujs 1.2.0

=== debian/changelog ===
mujs (1.2.0-3) unstable; urgency=high

  * Fix CVE-2022-30974 and CVE-2022-30975 via upstream patches

 -- Bastian Germann <bage@debian.org>  Tue, 05 Jul 2022 14:32:21 +0200

mujs (1.2.0-2) unstable; urgency=medium

  * Source-only reupload

 -- Bastian Germann <bage@debian.org>  Wed, 29 Jun 2022 00:48:14 +0200

mujs (1.2.0-1) experimental; urgency=medium

  * Import new version
  * Rebase patches to new version
  * Reflect ABI change in lib package rename

 -- Bastian Germann <bage@debian.org>  Sat, 18 Jun 2022 22:40:10 +0200

mujs (1.1.3-4) unstable; urgency=high

  * Clear jump list after patching jump addresses (CVE-2021-45005)

 -- Bastian Germann <bage@debian.org>  Fri, 25 Feb 2022 20:33:53 +0100

## mujs 1.3.0

=== debian/changelog ===
mujs (1.3.0-1) unstable; urgency=medium

  * d/watch: Scan also for tar.gz
  * New upstream version 1.3.0
  * Drop upstream patches

 -- Bastian Germann <bage@debian.org>  Sun, 06 Nov 2022 22:01:52 +0100

=== debian/watch ===
version=4
https://mujs.com/downloads/mujs-(\d\S+)\.tar\.[gx]z

## mujs 1.3.2

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,13 @@
 ifeq "$(wildcard .git)" ".git"
   VERSION := $(shell git describe --tags --always)
 else
-  VERSION := $(shell basename $$PWD | sed -e s,^mujs-,,)
+  VERSION := $(patsubst mujs-%,%,$(notdir $(CURDIR)))
+endif
+
+ifeq ($(shell uname),Darwin)
+	SO_EXT := dylib
+else
+	SO_EXT := so
 endif
 
 # Compiler flags for various configurations:
@@ -55,7 +61,7 @@
 default: shell
 shell: $(OUT)/mujs $(OUT)/mujs-pp
 static: $(OUT)/libmujs.a
-shared: $(OUT)/libmujs.so
+shared: $(OUT)/libmujs.$(SO_EXT)
 
 astnames.h: jsparse.h
 	grep -E '(AST|EXP|STM)_' jsparse.h | sed 's/^[^A-Z]*\(AST_\)*/"/;s/,.*/",/' | tr A-Z a-z > $@
@@ -69,31 +75,34 @@
 jsdump.c: astnames.h opnames.h
 
 $(OUT)/%.o: %.c $(HDRS)
-	@ mkdir -p $(dir $@)
+	@ mkdir -p $(@D)
 	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ -c $<
 
 $(OUT)/libmujs.o: one.c $(HDRS)
-	@ mkdir -p $(dir $@)
+	@ mkdir -p $(@D)
 	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ -c $<
 
 $(OUT)/libmujs.a: $(OUT)/libmujs.o
-	@ mkdir -p $(dir $@)
+	@ mkdir -p $(@D)
 	$(AR) cr $@ $^
 
-$(OUT)/libmujs.so: one.c $(HDRS)
-	@ mkdir -p $(dir $@)
+$(OUT)/libmujs.$(SO_EXT): one.c $(HDRS)
+	@ mkdir -p $(@D)
 	$(CC) $(CFLAGS) $(CPPFLAGS) -fPIC -shared $(LDFLAGS) -o $@ $< -lm
 
-$(OUT)/mujs: $(OUT)/libmujs.o $(OUT)/main.o
-	@ mkdir -p $(dir $@)
-	$(CC) $(LDFLAGS) -o $@ $^ $(LIBREADLINE) -lm
+libmujs ?= libmujs.a
 
-$(OUT)/mujs-pp: $(OUT)/libmujs.o $(OUT)/pp.o
-	@ mkdir -p $(dir $@)
-	$(CC) $(LDFLAGS) -o $@ $^ -lm
+$(OUT)/mujs: $(OUT)/main.o $(OUT)/$(libmujs)
+	@ mkdir -p $(@D)
+	$(CC) $(LDFLAGS) -o $@ $< -L$(OUT) -l:$(libmujs) $(LIBREADLINE) -lm
+
+$(OUT)/mujs-pp: $(OUT)/pp.o $(OUT)/$(libmujs)
+	@ mkdir -p $(@D)
+	$(CC) $(LDFLAGS) -o $@ $< -L$(OUT) -l:$(libmujs) -lm
 
 .PHONY: $(OUT)/mujs.pc
 $(OUT)/mujs.pc:
+	@ mkdir -p $(dir $@)
 	@ echo Creating $@
 	@ echo > $@ Name: mujs
 	@ echo >> $@ Description: MuJS embeddable Javascript interpreter
@@ -117,8 +126,8 @@
 install-static: install-common $(OUT)/libmujs.a
 	install -m 644 $(OUT)/libmujs.a $(DESTDIR)$(libdir)
 
-install-shared: install-common $(OUT)/libmujs.so
-	install -m 755 $(OUT)/libmujs.so $(DESTDIR)$(libdir)
+install-shared: install-common $(OUT)/libmujs.$(SO_EXT)
+	install -m 755 $(OUT)/libmujs.$(SO_EXT) $(DESTDIR)$(libdir)
 
 install: install-static
 
@@ -127,7 +136,7 @@
 	rm -f $(DESTDIR)$(incdir)/mujs.h
 	rm -f $(DESTDIR)$(libdir)/pkgconfig/mujs.pc
 	rm -f $(DESTDIR)$(libdir)/libmujs.a
-	rm -f $(DESTDIR)$(libdir)/libmujs.so
+	rm -f $(DESTDIR)$(libdir)/libmujs.$(SO_EXT)
 
 tarball:
 	git archive --format=zip --prefix=mujs-$(VERSION)/ HEAD > mujs-$(VERSION).zip

=== debian/changelog ===
mujs (1.3.2-1) unstable; urgency=medium

  * d/watch: Change to git because of lacking releases
  * New upstream version 1.3.2 (Fixes CVE-2022-44789)

 -- Bastian Germann <bage@debian.org>  Thu, 24 Nov 2022 17:11:57 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmujs1 (= ${binary:Version}), ${misc:Depends}
+Depends: libmujs2 (= ${binary:Version}), ${misc:Depends}
 Description: Lightweight JavaScript interpreter (development package)
  MuJS is a lightweight JavaScript interpreter designed for embedding in other
  software to extend them with scripting capabilities.
@@ -25,7 +25,7 @@
  byzantine C++ template mechanisms, or worry about marking and unmarking garbage
  collection roots, or wrestle with obscure build systems.
 
-Package: libmujs1
+Package: libmujs2
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- CFLAGS="$(CFLAGS) -Wl,-soname,libmujs.so.1" shared
+	dh_auto_build -- CFLAGS="$(CFLAGS) -Wl,-soname,libmujs.so.2" shared
 	dh_auto_build -- CFLAGS="$(CFLAGS)"
 
 override_dh_auto_install:

## mujs 1.3.3

=== debian/changelog ===
mujs (1.3.3-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:08:42 +0000

mujs (1.3.3-3build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 02:58:38 +0100

mujs (1.3.3-3) unstable; urgency=medium

  * QA upload
  * Orphan the package

 -- Bastian Germann <bage@debian.org>  Tue, 07 Nov 2023 00:30:17 +0100

mujs (1.3.3-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Build during dh_auto_build. (Closes: #1050910)

 -- Bastian Germann <bage@debian.org>  Thu, 31 Aug 2023 14:38:01 +0200

mujs (1.3.3-1) unstable; urgency=medium

  * New upstream version 1.3.3
  * Rebase patches
  * Use HTTPS for uscan
  * Rename binary pkg because of ABI change

 -- Bastian Germann <bage@debian.org>  Mon, 19 Jun 2023 10:23:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: mujs
 Priority: optional
-Maintainer: Bastian Germann <bage@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends: debhelper-compat (= 13), libreadline-dev
 Standards-Version: 4.5.0
 Section: javascript
@@ -13,7 +14,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmujs2 (= ${binary:Version}), ${misc:Depends}
+Depends: libmujs3 (= ${binary:Version}), ${misc:Depends}
 Description: Lightweight JavaScript interpreter (development package)
  MuJS is a lightweight JavaScript interpreter designed for embedding in other
  software to extend them with scripting capabilities.
@@ -25,7 +26,7 @@
  byzantine C++ template mechanisms, or worry about marking and unmarking garbage
  collection roots, or wrestle with obscure build systems.
 
-Package: libmujs2
+Package: libmujs3
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DESTDIR = debian/tmp
prefix=/usr
libdir=$(prefix)/lib/${DEB_HOST_MULTIARCH}
CFLAGS=$(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(CFLAGS) -Wl,-soname,libmujs.so.3" build/release/libmujs.so
	dh_auto_build -- prefix=$(prefix) libdir=$(libdir) CFLAGS="$(CFLAGS)" release

override_dh_auto_install:
	$(MAKE) prefix=$(prefix) libdir=$(libdir) install-shared
	dh_auto_install --destdir=$(DESTDIR) -- prefix=$(prefix) libdir=$(libdir)

## mujs 1.3.5

=== debian/changelog ===
mujs (1.3.5-1) unstable; urgency=medium

  * New upstream version 1.3.5
  * Refresh all patches
  * Set myself as maintainer. (Closes: #1055354)
  * Bump to Standards-Version 4.7.0
  * Update debian/libmujs3.symbols file.
  * debian/patches
    + Add Add_hardening_flags.diff patch.
  * debian/rules
    + Add LDFLAGS in dh_auto_build.
  * Add debian/upstream/metadata file.
  * Add debian/mujs.doc-base file.
  * debian/copyright
    + Add myself in debian copyright.

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 12 Oct 2024 12:03:55 -0500

## mujs 1.3.6

=== Makefile ===
# Makefile for building MuJS libraries, shell, and pretty-printer.
#
# Useful targets are: release, install, uninstall.

default: build/debug/mujs build/debug/mujs-pp

CFLAGS = -std=c99 -pedantic -Wall -Wextra -Wno-unused-parameter

OPTIM = -O3

prefix = /usr/local
bindir = $(prefix)/bin
incdir = $(prefix)/include
libdir = $(prefix)/lib

ifeq ($(wildcard .git),.git)
  VERSION = $(shell git describe --tags --always)
else
  VERSION = $(patsubst mujs-%,%,$(notdir $(CURDIR)))
endif

ifeq ($(shell uname),Darwin)
  SO = dylib
else
  SO = so
endif

ifeq ($(shell uname),FreeBSD)
  CFLAGS += -I/usr/local/include -L/usr/local/lib
endif

HDRS = mujs.h jsi.h regexp.h utf.h astnames.h opnames.h

ifneq ($(HAVE_READLINE),no)
  READLINE_CFLAGS = -DHAVE_READLINE
  READLINE_LIBS = -lreadline
endif

SRCS = \
	jsarray.c \
	jsboolean.c \
	jsbuiltin.c \
	jscompile.c \
	jsdate.c \
	jsdtoa.c \
	jserror.c \
	jsfunction.c \
	jsgc.c \
	jsintern.c \
	jslex.c \
	jsmath.c \
	jsnumber.c \
	jsobject.c \
	json.c \
	jsparse.c \
	jsproperty.c \
	jsregexp.c \
	jsrepr.c \
	jsrun.c \
	jsstate.c \
	jsstring.c \
	jsvalue.c \
	regexp.c \
	utf.c

one.c:
	for F in $(SRCS); do echo "#include \"$$F\""; done > $@

astnames.h: jsi.h
	grep -E '\<(AST|EXP|STM)_' jsi.h | sed 's/^[^A-Z]*\(AST_\)*/"/;s/,.*/",/' | tr A-Z a-z > $@

opnames.h: jsi.h
	grep -E '\<OP_' jsi.h | sed 's/^[^A-Z]*OP_/"/;s/,.*/",/' | tr A-Z a-z > $@

UnicodeData.txt:
	curl -s -o $@ https://www.unicode.org/Public/UCD/latest/ucd/UnicodeData.txt

utfdata.h: genucd.py UnicodeData.txt
	python3 genucd.py UnicodeData.txt >$@

build/sanitize/mujs: main.c one.c $(SRCS) $(HDRS)
	@mkdir -p $(@D)
	$(CC) $(CFLAGS) -g -fsanitize=address -fno-omit-frame-pointer -o $@ main.c one.c -lm $(READLINE_CFLAGS) $(READLINE_LIBS)

build/debug/libmujs.$(SO): one.c $(SRCS) $(HDRS)
	@mkdir -p $(@D)
	$(CC) $(CFLAGS) -g -fPIC -shared -o $@ one.c -lm
build/debug/libmujs.o: one.c $(SRCS) $(HDRS)
	@mkdir -p $(@D)
	$(CC) $(CFLAGS) -g -c -o $@ one.c
build/debug/libmujs.a: build/debug/libmujs.o
	$(AR) cr $@ $^
build/debug/mujs: main.c build/debug/libmujs.o
	$(CC) $(CFLAGS) -g -o $@ $^ -lm $(READLINE_CFLAGS) $(READLINE_LIBS)
build/debug/mujs-pp: pp.c build/debug/libmujs.o
	$(CC) $(CFLAGS) -g -o $@ $^ -lm

build/release/libmujs.$(SO): one.c $(SRCS) $(HDRS)
	@mkdir -p $(@D)
	$(CC) $(CFLAGS) $(OPTIM) -fPIC -shared -o $@ one.c -lm
build/release/libmujs.o: one.c $(SRCS) $(HDRS)
	@mkdir -p $(@D)
	$(CC) $(CFLAGS) $(OPTIM) -c -o $@ one.c
build/release/libmujs.a: build/release/libmujs.o
	$(AR) cr $@ $^
build/release/mujs: main.c build/release/libmujs.o
	$(CC) $(CFLAGS) $(OPTIM) -o $@ $^ -lm $(READLINE_CFLAGS) $(READLINE_LIBS)
build/release/mujs-pp: pp.c build/release/libmujs.o
	$(CC) $(CFLAGS) $(OPTIM) -o $@ $^ -lm

build/release/mujs.pc:
	@mkdir -p $(@D)
	echo > $@ Name: mujs
	echo >> $@ Description: MuJS embeddable Javascript interpreter
	echo >> $@ Version: $(VERSION)
	echo >> $@ Cflags: -I$(incdir)
	echo >> $@ Libs: -L$(libdir) -lmujs
	echo >> $@ Libs.private: -lm

install-common: build/release/mujs build/release/mujs-pp build/release/mujs.pc
	install -d $(DESTDIR)$(incdir)
	install -d $(DESTDIR)$(libdir)
	install -d $(DESTDIR)$(libdir)/pkgconfig
	install -d $(DESTDIR)$(bindir)
	install -m 644 mujs.h $(DESTDIR)$(incdir)
	install -m 644 build/release/mujs.pc $(DESTDIR)$(libdir)/pkgconfig
	install -m 755 build/release/mujs $(DESTDIR)$(bindir)
	install -m 755 build/release/mujs-pp $(DESTDIR)$(bindir)

install-static: install-common build/release/libmujs.a
	install -m 644 build/release/libmujs.a $(DESTDIR)$(libdir)

install-shared: install-common build/release/libmujs.$(SO)
	install -m 755 build/release/libmujs.$(SO) $(DESTDIR)$(libdir)

install: install-static

uninstall:
	rm -f $(DESTDIR)$(bindir)/mujs
	rm -f $(DESTDIR)$(bindir)/mujs-pp
	rm -f $(DESTDIR)$(incdir)/mujs.h
	rm -f $(DESTDIR)$(libdir)/pkgconfig/mujs.pc
	rm -f $(DESTDIR)$(libdir)/libmujs.a
	rm -f $(DESTDIR)$(libdir)/libmujs.$(SO)

tarball:
	git archive --format=zip --prefix=mujs-$(VERSION)/ HEAD > mujs-$(VERSION).zip
	git archive --format=tar --prefix=mujs-$(VERSION)/ HEAD | gzip > mujs-$(VERSION).tar.gz

tags: $(SRCS) $(HDRS) main.c pp.c
	ctags $^

clean:
	rm -rf build

nuke: clean
	rm -f one.c astnames.h opnames.h

sanitize: build/sanitize/mujs

debug: build/debug/libmujs.a
debug: build/debug/libmujs.$(SO)
debug: build/debug/mujs
debug: build/debug/mujs-pp

release: build/release/mujs.pc
release: build/release/libmujs.a
release: build/release/libmujs.$(SO)
release: build/release/mujs
release: build/release/mujs-pp

=== debian/changelog ===
mujs (1.3.6-1) unstable; urgency=medium

  * New upstream version 1.3.6
  * debian/copyright
    + Extend copyright debian holders years

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 08 Feb 2025 15:30:35 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: mujs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Daniel Echeverri <epsilon@debian.org>
 Build-Depends: debhelper-compat (= 13), libreadline-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.7.0
 Section: javascript
 Rules-Requires-Root: no
 Homepage: https://mujs.com/

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- CFLAGS="$(CFLAGS) -Wl,-soname,libmujs.so.3" build/release/libmujs.so
+	dh_auto_build -- CFLAGS="$(CFLAGS) $(LDFLAGS) $(CPPFLAGS) -Wl,-soname,libmujs.so.3" build/release/libmujs.so
 	dh_auto_build -- prefix=$(prefix) libdir=$(libdir) CFLAGS="$(CFLAGS)" release
 
 override_dh_auto_install:

=== debian/watch ===
version=4
opts=mode=git,gitmode=full \
https://git.ghostscript.com/mujs.git refs/tags/(\d\S+)

## mujs 1.3.7

=== debian/changelog ===
mujs (1.3.7-1) experimental; urgency=medium

  * New upstream release.
  * debian/control
    + Add unicode-data in B-D.
    + Bump to Standards-Version 4.7.2.
  * debian/patches
    + Refresh all patches.
    + Add use-system-unicode-data.diff patch
      + Use system Unicode data instead of downloading.
  * debian/libmujs3.symbols
    + Add new symbols.
  * debian/watch
    + Use file format 5 and change source to mujs website.

 -- Daniel Echeverri <epsilon@debian.org>  Sun, 12 Oct 2025 15:33:30 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: mujs
 Priority: optional
 Maintainer: Daniel Echeverri <epsilon@debian.org>
-Build-Depends: debhelper-compat (= 13), libreadline-dev
-Standards-Version: 4.7.0
+Build-Depends: debhelper-compat (= 13), libreadline-dev, unicode-data
+Standards-Version: 4.7.2
 Section: javascript
 Rules-Requires-Root: no
 Homepage: https://mujs.com/

=== debian/watch ===
Version: 5
Source: https://mujs.com/downloads/
Matching-Pattern: mujs-@ANY_VERSION@@ARCHIVE_EXT@
Search-Mode: html

## mujs 1.3.8

=== debian/changelog ===
mujs (1.3.8-2) unstable; urgency=medium

  * Move experimental to unstable

 -- Daniel Echeverri <epsilon@debian.org>  Fri, 19 Dec 2025 21:48:22 -0500

mujs (1.3.8-1) experimental; urgency=medium

  * New upstream version 1.3.8
  * debian/control
    + Remove Rules-Requires-Root field
  * debian/libmujs3.symbols
    + Add new symbols

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 13 Dec 2025 18:35:52 -0500

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Build-Depends: debhelper-compat (= 13), libreadline-dev, unicode-data
 Standards-Version: 4.7.2
 Section: javascript
-Rules-Requires-Root: no
 Homepage: https://mujs.com/
 Vcs-Browser: https://salsa.debian.org/debian/mujs
 Vcs-Git: https://salsa.debian.org/debian/mujs.git
